## ros-foxy-moveit-servo 2.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(moveit_servo)

# C++ Libraries #################################################

# Core C++ library for calculations and collision checking.
# Provides interface used by the component node.
set(SERVO_LIB_NAME moveit_servo_lib)
# C++ library containing the parameters initialization
# - This is intended to use with the component node when you
# -   need to read the parameters loaded into servo in a separate
# -   node.
set(SERVO_PARAM_LIB_NAME ${SERVO_LIB_NAME}_parameters)

# Pose Tracking
set(POSE_TRACKING pose_tracking)

# Component Nodes (Shared libraries) ############################
set(SERVO_COMPONENT_NODE servo_server)
set(SERVO_CONTROLLER_INPUT servo_controller_input)

# Executable Nodes ##############################################
set(POSE_TRACKING_DEMO_NAME servo_pose_tracking_demo)
set(FAKE_SERVO_CMDS_NAME fake_command_publisher)

#################################################################

# Common cmake code applied to all moveit packages
find_package(moveit_common REQUIRED)
moveit_package()

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(std_msgs REQUIRED)
find_package(std_srvs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(control_msgs REQUIRED)
find_package(control_toolbox REQUIRED)
find_package(moveit_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(tf2_eigen REQUIRED)
find_package(trajectory_msgs REQUIRED)
find_package(moveit_ros_planning REQUIRED)
find_package(eigen3_cmake_module REQUIRED)
find_package(Eigen3 REQUIRED)

set(THIS_PACKAGE_INCLUDE_DEPENDS
  rclcpp
  rclcpp_components
  std_msgs
  std_srvs
  sensor_msgs
  control_msgs
  control_toolbox
  moveit_msgs
  geometry_msgs
  tf2_eigen
  trajectory_msgs
  moveit_ros_planning
)

include_directories(
  include
)

###################
## C++ Libraries ##
###################

# This library provides a way of loading parameters for servo
add_library(${SERVO_PARAM_LIB_NAME} SHARED src/servo_parameters.cpp)
set_target_properties(${SERVO_PARAM_LIB_NAME} PROPERTIES VERSION "${${PROJECT_NAME}_VERSION}")
ament_target_dependencies(${SERVO_PARAM_LIB_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})

# This library provides a C++ interface for sending realtime twist or joint commands to a robot
add_library(${SERVO_LIB_NAME} SHARED
  # These files are used to produce differential motion
  src/collision_check.cpp
  src/enforce_limits.cpp
  src/low_pass_filter.cpp
  src/servo.cpp
  src/servo_calcs.cpp
)
set_target_properties(${SERVO_LIB_NAME} PROPERTIES VERSION "${${PROJECT_NAME}_VERSION}")
ament_target_dependencies(${SERVO_LIB_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_link_libraries(${SERVO_LIB_NAME} ${SERVO_PARAM_LIB_NAME})

add_library(${POSE_TRACKING} SHARED src/pose_tracking.cpp)
ament_target_dependencies(${POSE_TRACKING} ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_link_libraries(${POSE_TRACKING} ${SERVO_LIB_NAME})

#####################
## Component Nodes ##
#####################

# Add and export library to run as a ROS node component, and receive commands via topics
add_library(${SERVO_COMPONENT_NODE} SHARED src/servo_server.cpp)
ament_target_dependencies(${SERVO_COMPONENT_NODE} ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_link_libraries(${SERVO_COMPONENT_NODE} ${SERVO_LIB_NAME})
rclcpp_components_register_nodes(${SERVO_COMPONENT_NODE} "moveit_servo::ServoServer")

# Add executable for using a controller
add_library(${SERVO_CONTROLLER_INPUT} SHARED src/teleop_demo/joystick_servo_example.cpp)
ament_target_dependencies(${SERVO_CONTROLLER_INPUT} ${THIS_PACKAGE_INCLUDE_DEPENDS})
rclcpp_components_register_nodes(${SERVO_CONTROLLER_INPUT} "moveit_servo::JoyToServoPub")

######################
## Executable Nodes ##
######################

# An example of pose tracking
add_executable(${POSE_TRACKING_DEMO_NAME} src/cpp_interface_demo/pose_tracking_demo.cpp)
target_link_libraries(${POSE_TRACKING_DEMO_NAME} ${POSE_TRACKING})
ament_target_dependencies(${POSE_TRACKING_DEMO_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})

# Add executable to publish fake servo commands for testing/demo purposes
add_executable(${FAKE_SERVO_CMDS_NAME} test/publish_fake_jog_commands.cpp)
ament_target_dependencies(${FAKE_SERVO_CMDS_NAME}
  rclcpp
  geometry_msgs
  std_srvs
)

#############
## Install ##
#############

# Install Libraries
install(
  TARGETS
    ${SERVO_LIB_NAME}
    ${SERVO_LIB_NAME}_parameters
    ${POSE_TRACKING}
    ${SERVO_COMPONENT_NODE}
    ${SERVO_CONTROLLER_INPUT}
  EXPORT export_${PROJECT_NAME}
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include
)

# Install Binaries
install(
  TARGETS
    ${CPP_DEMO_NAME}
    ${POSE_TRACKING_DEMO_NAME}
    ${FAKE_SERVO_CMDS_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

# Install include, launch, config directories
install(DIRECTORY include/ DESTINATION include)
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME})
install(DIRECTORY config DESTINATION share/${PROJECT_NAME})

ament_export_targets(export_${PROJECT_NAME} HAS_LIBRARY_TARGET)
ament_export_dependencies(${THIS_PACKAGE_INCLUDE_DEPENDS})

#############
## TESTING ##
#############

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ros_testing REQUIRED)
  find_package(Boost REQUIRED COMPONENTS filesystem)

  # These don't pass yet, disable them for now
  set(ament_cmake_copyright_FOUND TRUE)
  set(ament_cmake_cppcheck_FOUND TRUE)
  set(ament_cmake_cpplint_FOUND TRUE)
  set(ament_cmake_flake8_FOUND TRUE)
  set(ament_cmake_uncrustify_FOUND TRUE)

  # Run all lint tests in package.xml except those listed above
  ament_lint_auto_find_test_dependencies()

  # Lowpass filter unit test
  ament_add_gtest(test_low_pass_filter test/test_low_pass_filter.cpp)
  target_link_libraries(test_low_pass_filter ${SERVO_LIB_NAME})

  # TODO(andyz): re-enable integration tests when they are less flakey.
  # The issue is that the test completes successfully but a results file is not generated.

  # # Unit test for ServoCalcs
  # ament_add_gtest_executable(
  #   unit_test_servo_calcs
  #   test/unit_test_servo_calcs.cpp
  # )
  # target_link_libraries(unit_test_servo_calcs ${SERVO_LIB_NAME})
  # ament_target_dependencies(unit_test_servo_calcs ${THIS_PACKAGE_INCLUDE_DEPENDS} Boost)
  # add_ros_test(test/launch/unit_test_servo_calcs.test.py ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # # Servo integration launch test
  # ament_add_gtest_executable(test_servo_integration
  #     test/test_servo_interface.cpp
  #     test/servo_launch_test_common.hpp
  # )
  # target_link_libraries(test_servo_integration ${SERVO_PARAM_LIB_NAME})
  # ament_target_dependencies(test_servo_integration ${THIS_PACKAGE_INCLUDE_DEPENDS})
  # add_ros_test(test/launch/test_servo_integration.test.py ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # # Servo collision checking integration test
  # ament_add_gtest_executable(test_servo_collision
  #       test/test_servo_collision.cpp
  #       test/servo_launch_test_common.hpp
  # )
  # target_link_libraries(test_servo_collision ${SERVO_PARAM_LIB_NAME})
  # ament_target_dependencies(test_servo_collision ${THIS_PACKAGE_INCLUDE_DEPENDS})
  # add_ros_test(test/launch/test_servo_collision.test.py ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # # Servo singularity checking integration test
  # ament_add_gtest_executable(test_servo_singularity
  #       test/test_servo_singularity.cpp
  #       test/servo_launch_test_common.hpp
  # )
  # target_link_libraries(test_servo_singularity ${SERVO_PARAM_LIB_NAME})
  # ament_target_dependencies(test_servo_singularity ${THIS_PACKAGE_INCLUDE_DEPENDS})
  # add_ros_test(test/launch/test_servo_singularity.test.py ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # TODO(henningkayser): Port tests to ROS2
  # servo_cpp_interface
  # add_rostest_gtest(servo_cpp_interface_test
  #   test/servo_cpp_interface_test.test
  #   test/servo_cpp_interface_test.cpp
  # )
  # target_link_libraries(servo_cpp_interface_test
  #   ${SERVO_LIB_NAME}
  #   ${catkin_LIBRARIES}
  # )

  # # pose_tracking
  # ament_add_gtest_executable(test_servo_pose_tracking
  #       test/pose_tracking_test.cpp
  # )
  # ament_target_dependencies(test_servo_pose_tracking ${THIS_PACKAGE_INCLUDE_DEPENDS})
  # target_link_libraries(test_servo_pose_tracking ${POSE_TRACKING})
  # add_ros_test(test/launch/test_servo_pose_tracking.test.py ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # # basic_servo_tests
  # ament_add_gtest_executable(basic_servo_tests
  #       test/basic_servo_tests.cpp
  # )
  # ament_target_dependencies(basic_servo_tests ${THIS_PACKAGE_INCLUDE_DEPENDS})
  # target_link_libraries(basic_servo_tests ${POSE_TRACKING})
  # add_ros_test(test/launch/test_basic_servo.test.py ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # Enforce limits unit tests
  ament_add_gtest(enforce_limits_tests
    test/enforce_limits_tests.cpp
  )
  target_link_libraries(enforce_limits_tests ${SERVO_LIB_NAME})

endif()

ament_package()

=== debian/changelog ===
ros-foxy-moveit-servo (2.2.3-1focal) focal; urgency=high



 -- Blake Anderson <blakeanderson@utexas.edu>  Fri, 07 Jan 2022 07:00:00 -0000

ros-foxy-moveit-servo (2.2.2-1focal) focal; urgency=high

  * Migrate to joint_state_broadcaster (#656 <https://github.com/ros-planning/moveit2/issues/656>)
  * Fix missing include in servo example (#609 <https://github.com/ros-planning/moveit2/issues/609>)
  * Fix loading joint_limits.yaml in demo and test launch files (#544 <https://github.com/ros-planning/moveit2/issues/544>)
  * Fixes for Windows (#530 <https://github.com/ros-planning/moveit2/issues/530>)
  * Refactor out velocity limit enforcement with test (#540 <https://github.com/ros-planning/moveit2/issues/540>)
  * Refactor moveit_servo::LowPassFilter to be assignable (#572 <https://github.com/ros-planning/moveit2/issues/572>)
  * Fix MoveIt Servo compilation on macOS (#555 <https://github.com/ros-planning/moveit2/issues/555>)
  * Fix segfault if servo collision checking is disabled (#568 <https://github.com/ros-planning/moveit2/issues/568>)
  * Contributors: Akash, Griswald Brooks, Joseph Schornak, Nisala Kalupahana, Lior Lustgarten, Tyler Weaver, Vatan Aksoy Tezer, Henning Kayser, Jorge Nicho, Nisala Kalupahana, Jafar Abdi, Adam Pettinger

 -- Blake Anderson <blakeanderson@utexas.edu>  Tue, 16 Nov 2021 07:00:00 -0000

ros-foxy-moveit-servo (2.2.1-1focal) focal; urgency=high

  * moveit_servo: Add a parameter to halt only joints that violate position limits  (#515 <https://github.com/ros-planning/moveit2/issues/515>)
    Add halt_all_joints_in_joint_mode & halt_all_joints_in_cartesian_mode parameters to decide whether to halt all joints or some of them in case of joint limit violation
  * Contributors: Jafar Abdi

 -- Blake Anderson <blakeanderson@utexas.edu>  Mon, 12 Jul 2021 06:00:00 -0000

ros-foxy-moveit-servo (2.2.0-1focal) focal; urgency=high

  * Allow a negative joint margin (#501 <https://github.com/ros-planning/moveit2/issues/501>)
  * Move servo doc and examples to moveit2_tutorials (#486 <https://github.com/ros-planning/moveit2/issues/486>)
  * Remove faulty gtest include (#526 <https://github.com/ros-planning/moveit2/issues/526>)
  * Fix segfault when publish_joint_velocities set to false and a joint is close to position limit (#497 <https://github.com/ros-planning/moveit2/issues/497>)
  * Enable Rolling and Galactic CI (#494 <https://github.com/ros-planning/moveit2/issues/494>)
  * [sync] MoveIt's master branch up-to https://github.com/ros-planning/moveit/commit/0d0a6a171b3fbea97a0c4f284e13433ba66a4ea4
    * Misspelled MoveIt (#2692 <https://github.com/ros-planning/moveit/issues/2692>)
    * Avoid joint jump when SuddenHalt() is called in velocity mode (#2594 <https://github.com/ros-planning/moveit/issues/2594>)
    * Halt Servo command on Pose Tracking stop (#2501 <https://github.com/ros-planning/moveit/issues/2501>)
    * stop_requested_ flag clearing fix (#2537 <https://github.com/ros-planning/moveit/issues/2537>)
    * add missing include (#2519 <https://github.com/ros-planning/moveit/issues/2519>)
    * Refactor velocity bounds enforcement (#2471 <https://github.com/ros-planning/moveit/issues/2471>)
  * Contributors: AdamPettinger, AndyZe, Henning Kayser, Jafar Abdi, JafarAbdi, Jere Liukkonen, Michael Görner, Nathan Brooks, Robert Haschke, Tyler Weaver, Vatan Aksoy Tezer, parunapu

 -- Blake Anderson <blakeanderson@utexas.edu>  Wed, 30 Jun 2021 06:00:00 -0000

ros-foxy-moveit-servo (2.1.4-1focal) focal; urgency=high

  * Delete MoveIt fake_controller_manager (#471 <https://github.com/ros-planning/moveit2/issues/471>)
  * Contributors: AndyZe

 -- Blake Anderson <blakeanderson@utexas.edu>  Mon, 31 May 2021 06:00:00 -0000

ros-foxy-moveit-servo (2.1.3-1focal) focal; urgency=high

  * Refactor Servo velocity bounds enforcement. Disable flaky unit tests. (#428 <https://github.com/ros-planning/moveit2/issues/428>)
  * Fix joint limit handling when velocities aren't included in robot state (#451 <https://github.com/ros-planning/moveit2/issues/451>)
  * Fix Servo logging frequency (#457 <https://github.com/ros-planning/moveit2/issues/457>)
  * Replace last ament_export_libraries macro calls with ament_export_targets (#448 <https://github.com/ros-planning/moveit2/issues/448>)
  * Contributors: AndyZe, Sebastian Jahr, Vatan Aksoy Tezer

 -- Blake Anderson <blakeanderson@utexas.edu>  Sat, 22 May 2021 06:00:00 -0000

ros-foxy-moveit-servo (2.1.2-1focal) focal; urgency=high

  * Re-enable test_servo_pose_tracking integration test (#423 <https://github.com/ros-planning/moveit2/issues/423>)
    Co-authored-by: AndyZe <mailto:zelenak@picknik.ai>
  * Unify PickNik name in copyrights (#419 <https://github.com/ros-planning/moveit2/issues/419>)
  * Contributors: Tyler Weaver, Vatan Aksoy Tezer

 -- Blake Anderson <blakeanderson@utexas.edu>  Tue, 20 Apr 2021 06:00:00 -0000

ros-foxy-moveit-servo (2.1.1-1focal) focal; urgency=high

  * Do not output positions at all if they are set to false (#410 <https://github.com/ros-planning/moveit2/issues/410>)
  * Update launch files to use ros2 control spawner (#405 <https://github.com/ros-planning/moveit2/issues/405>)
  * Include boost optional in pose_tracking (#406 <https://github.com/ros-planning/moveit2/issues/406>)
  * Use fake_components::GenericSystem from ros2_control (#361 <https://github.com/ros-planning/moveit2/issues/361>)
  * Fix EXPORT install in CMake (#372 <https://github.com/ros-planning/moveit2/issues/372>)
  * moveit servo: fix constructing duration from double & fix bug in insertRedundantPointsIntoTrajectory function (#374 <https://github.com/ros-planning/moveit2/issues/374>)
  * port pose tracking (#320 <https://github.com/ros-planning/moveit2/issues/320>)
  * Fix 'start_servo' service topic in demo
  * Sync main branch with MoveIt 1 from previous head https://github.com/ros-planning/moveit/commit/0247ed0027ca9d7f1a7f066e62c80c9ce5dbbb5e up to https://github.com/ros-planning/moveit/commit/74b3e30db2e8683ac17b339cc124675ae52a5114


=== debian/control ===
Source: ros-foxy-moveit-servo
Section: misc
Priority: optional
Maintainer: Blake Anderson <blakeanderson@utexas.edu>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-control-msgs, ros-foxy-control-toolbox, ros-foxy-geometry-msgs, ros-foxy-moveit-common, ros-foxy-moveit-msgs, ros-foxy-moveit-resources-panda-moveit-config, ros-foxy-moveit-ros-planning-interface, ros-foxy-ros-testing, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-std-srvs, ros-foxy-tf2-eigen, ros-foxy-trajectory-msgs, ros-foxy-ros-workspace
Homepage: https://ros-planning.github.io/moveit_tutorials
Standards-Version: 3.9.2

Package: ros-foxy-moveit-servo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-control-msgs, ros-foxy-control-toolbox, ros-foxy-geometry-msgs, ros-foxy-gripper-controllers, ros-foxy-joint-state-broadcaster, ros-foxy-joint-trajectory-controller, ros-foxy-joy, ros-foxy-moveit-msgs, ros-foxy-moveit-ros-planning-interface, ros-foxy-robot-state-publisher, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-std-srvs, ros-foxy-tf2-eigen, ros-foxy-tf2-ros, ros-foxy-trajectory-msgs, ros-foxy-ros-workspace
Description: Provides real-time manipulator Cartesian and joint servoing.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-moveit-servo//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
